<!-- manual page source format generated by PolyglotMan v3.0.7, -->
<!-- available via anonymous ftp from ftp.cs.berkeley.edu:/ucb/people/phelps/tcltk/rman.tar.Z -->

<HTML>
<HEAD>
<TITLE>Man page for nsharlit.1</TITLE>
</HEAD>
<BODY bgcolor=white>
<A HREF="#toc">Table of Contents</A><P>

<H2><A NAME="sect0" HREF="#toc0">Name</A></H2>

<P>
sharlit, nsharlit - generate data-flow analyzers

<H2><A NAME="sect1" HREF="#toc1"><B>Synopsis</B></A></H2>

<P>
<B>sharlit</B> [ <I>options</I> ] <I>infile</I>

<H2><A NAME="sect2" HREF="#toc2"><B>Description</B></A></H2>

<P>
<I>Sharlit</I> and <I>nsharlit</I> take descriptions of data-flow analyzers
and generate C++ classes to perform data-flow analysis.
Sharlit uses old SUIF libraries and is used by oynk
to implement its optimization analysis phases, while
nsharlit uses new SUIF libraries and is used by moo to
implement its scalar privatization analysis.
<P>
<I>Sharlit</I> and <I>nsharlit</I> generate two files: <B>solver.h</B> and
<B>solver.c</B>. These files contain the definitions for classes
that implement the data-flow analyzer, the flow functions
and flow values.
<P>
Sharlit supports a style of optimization based on a model
by Kildall, in which each phase consists of a data-flow
analysis (DFA) of the program and an optimization function
that transforms the program. To support the model, a set
of abstractions --- flow values, flow functions, path simplification
rules, action routines --- is provided. Sharlit
turns a DFA specifiation consisting of these abstractions
into a solver for a DFA problem. At the heart of
Sharlit is an algorithm called path simplification, an
extension of Tarjan's fast path algorithm. Path simplification
unifies several powerful DFA solution techniques.
By using path simplfication rules, compiler writers can
construct a wide range of data-flow analyzers, from simple
iterative ones, to solvers that use local analysis, interval
analysis, or sparse data-flow evaluation.
<P>
For more information, consult the literature listed below.

<H2><A NAME="sect3" HREF="#toc3"><B>Options</B></A></H2>


<DL>

<DT><B>-L</B> </DT></DT>
<DD>    This causes Sharlit to generate #line directives
for debugging purposes.
</DD>

<DT><B>-T</B> </DT></DT>
<DD>    causes Sharlit to used a switch-based technique to
apply path reduction rules in place of a parsingbased
technique. The latter technique is no longer
recommended, although some of the older phases of
oynk still use it.
</DD>
</DL>

<H2><A NAME="sect4" HREF="#toc4"><B>See</B> <B>Also</B></A></H2>

<P>
<A HREF="man_oynk.1.html">oynk(1)</A>
, <A HREF="man_moo.1.html">moo(1)</A>
<BR>

S. Tjiang and J. Hennessy. Sharlit: A tool for building
optimizers. In <I>SIGPLAN</I> <I>Conference</I> <I>on</I> <I>Programming</I> <I>Language</I>
<I>Design</I> <I>and</I> <I>Implementation,</I> 1992, pp 82-93.
S. Tjiang. <I>Automatic</I> <I>Generation</I> <I>of</I> <I>Data-flow</I> <I>Analyzers:</I> <I>A</I>
<I>tool</I> <I>for</I> <I>building</I> <I>optimizers</I> Ph.D. Thesis, Stanford
<P>
University, July 1993.

<H2><A NAME="sect5" HREF="#toc5"><B>Notes</B></A></H2>

<P>
Sharlit needs to be rewritten so that it uses a notation
more amenable to incorporation into C++.

<H2><A NAME="sect6" HREF="#toc6"><B>History</B></A></H2>

<P>
Sharlit and nsharlit were written by Steve Tjiang.
<P>

<HR><P>
<A NAME="toc"><B>Table of Contents</B></A><P>
<UL>
<LI><A NAME="toc0" HREF="#sect0">Name</A></LI>
<LI><A NAME="toc1" HREF="#sect1">Synopsis</A></LI>
<LI><A NAME="toc2" HREF="#sect2">Description</A></LI>
<LI><A NAME="toc3" HREF="#sect3">Options</A></LI>
<LI><A NAME="toc4" HREF="#sect4">See Also</A></LI>
<LI><A NAME="toc5" HREF="#sect5">Notes</A></LI>
<LI><A NAME="toc6" HREF="#sect6">History</A></LI>
</UL>
</BODY></HTML>
